﻿function Get-UserLogons {
    # Retrieve a list of logons by a user based on the UserTrack SQL database
    [CmdletBinding()]
    param (
        [Parameter(Mandatory = $true)]
        [String]$UserName,
        [Parameter(Mandatory = $false)]
        [datetime]$StartDate = '1/1/2017',
        [Parameter(Mandatory = $false)]
        [String]$SQLServer,
        [Parameter(Mandatory = $false)]
        [String]$Database = 'usertrack',
        [Parameter(Mandatory = $false)]
        [pscredential]$Credential,
        [Parameter(Mandatory = $false)]
        [Switch]$Unique,
        [Parameter(Mandatory = $false)]
        [Switch]$Latest
    )

    if (!(Get-Module -Name SqlServer -ErrorAction SilentlyContinue)) {
        Import-Module -Name SqlServer
    }
    
    if($Latest) {
        $Query = "SELECT TOP(1) * FROM logtable WHERE user_name = '$UserName' ORDER BY date DESC"
    } else {
        $Query = "SELECT * FROM logtable WHERE user_name = '$UserName' and date >= '$StartDate' ORDER BY date DESC"
    }

    $Result = Invoke-Sqlcmd -ServerInstance $SQLServer -Database $Database -Query $Query #| Out-GridView

    if($Unique) {
        $Result | Sort-Object -Property computer_name -Unique
    } else {
        $Result
    }
}
# SIG # Begin signature block
# MIIQtgYJKoZIhvcNAQcCoIIQpzCCEKMCAQExCzAJBgUrDgMCGgUAMGkGCisGAQQB
# gjcCAQSgWzBZMDQGCisGAQQBgjcCAR4wJgIDAQAABBAfzDtgWUsITrck0sYpfvNR
# AgEAAgEAAgEAAgEAAgEAMCEwCQYFKw4DAhoFAAQURzGBZ2lowRU1pBt8B4VJJIQ/
# zieggg6MMIIG5zCCBM+gAwIBAgITOwAEGocY570pFDMA/wADAAQahzANBgkqhkiG
# 9w0BAQsFADBdMRMwEQYKCZImiZPyLGQBGRYDZWR1MRgwFgYKCZImiZPyLGQBGRYI
# bW9ubW91dGgxLDAqBgNVBAMTI01vbm1vdXRoIFVuaXZlcnNpdHkgSW50ZXJtZWRp
# YXRlIElJMB4XDTIwMDEwMjIwMDEwNloXDTI0MDkwMzE0NTAxNVowgbwxEzARBgoJ
# kiaJk/IsZAEZFgNlZHUxGDAWBgoJkiaJk/IsZAEZFghtb25tb3V0aDEXMBUGA1UE
# CxMOQWRtaW5pc3RyYXRvcnMxHzAdBgNVBAsTFkluZm9ybWF0aW9uIE1hbmFnZW1l
# bnQxHDAaBgNVBAsTE0luZm9ybWF0aW9uIFN1cHBvcnQxGTAXBgNVBAsTEENvbXB1
# dGVyIFN1cHBvcnQxGDAWBgNVBAMMD0JhZG9fQWRtaW4sIE1heDCBnzANBgkqhkiG
# 9w0BAQEFAAOBjQAwgYkCgYEAw1At7znMlOscY2PNu5+a/uk/kZgyfK6Tt0dX4QSW
# 41D99F7NMBFjgcNwrjsq5AmYO95V2Ng9Y7AaoWOzsjhYbPyPq3CrbZgP9Ec05XHn
# GNYG7KmGIQ/WAg/gm/btcRxhgUnEns1pp8bw5zHjg6JYvgLq6by5wefUiK+z3KEq
# bqUCAwEAAaOCAsIwggK+MDwGCSsGAQQBgjcVBwQvMC0GJSsGAQQBgjcVCI3MSIa0
# lQjFiSCE+eU7hbS6CYFDguSiPoOEzHoCAWQCAQQwEwYDVR0lBAwwCgYIKwYBBQUH
# AwMwCwYDVR0PBAQDAgeAMBsGCSsGAQQBgjcVCgQOMAwwCgYIKwYBBQUHAwMwHQYD
# VR0OBBYEFCEVlk3887I4ogw2qr4Oubb8loruMB8GA1UdIwQYMBaAFA6eCbixKzWG
# 1q981j8rIJLKxUq2MIHqBgNVHR8EgeIwgd8wgdyggdmggdaGgdNsZGFwOi8vL0NO
# PU1vbm1vdXRoJTIwVW5pdmVyc2l0eSUyMEludGVybWVkaWF0ZSUyMElJLENOPXds
# Yi1jYS0wMixDTj1DRFAsQ049UHVibGljJTIwS2V5JTIwU2VydmljZXMsQ049U2Vy
# dmljZXMsQ049Q29uZmlndXJhdGlvbixEQz1tb25tb3V0aCxEQz1lZHU/Y2VydGlm
# aWNhdGVSZXZvY2F0aW9uTGlzdD9iYXNlP29iamVjdENsYXNzPWNSTERpc3RyaWJ1
# dGlvblBvaW50MIHcBggrBgEFBQcBAQSBzzCBzDCByQYIKwYBBQUHMAKGgbxsZGFw
# Oi8vL0NOPU1vbm1vdXRoJTIwVW5pdmVyc2l0eSUyMEludGVybWVkaWF0ZSUyMElJ
# LENOPUFJQSxDTj1QdWJsaWMlMjBLZXklMjBTZXJ2aWNlcyxDTj1TZXJ2aWNlcyxD
# Tj1Db25maWd1cmF0aW9uLERDPW1vbm1vdXRoLERDPWVkdT9jQUNlcnRpZmljYXRl
# P2Jhc2U/b2JqZWN0Q2xhc3M9Y2VydGlmaWNhdGlvbkF1dGhvcml0eTAzBgNVHREE
# LDAqoCgGCisGAQQBgjcUAgOgGgwYbWJhZG9fYWRtaW5AbW9ubW91dGguZWR1MA0G
# CSqGSIb3DQEBCwUAA4ICAQB7BaKoYokarFqklc5GM5GzfQmUCs+prhEO8cAv78Rt
# nAiSr90ebV2WWcRoWFB0HMiT9cSVsBNWbkypT/1vHSlHGqluVxkXN3wBX6dQW5xP
# 6K20Od67JD3vqkFUeNBhwrpzW5kxbSdX4FeO46TXh60d6/VDb4b/l1Lku5j+oxr5
# fMIPnL5OtNhw8M4nNvpFgIupp+a89RnYem0249OkSR8g5IgCNJnLRZxBj9+BHEgX
# OfHZL+LshXCYL3TNlvj2UQnFtOBxIwVhPocKLwXwje3QvZX0Qb7+HOZdbZtULvtQ
# F8crXOQ3qDxvGqZ+rLzKrQzkges11ymwPlmZ0ar4YR/DBzQn0sat4xBjRNp3pUy+
# glO1EMLbU31ZQQv7BTgewyKw0NHekeOv2I4QrYGN8l71C/XpgiUMNyGEdIJrFAeO
# ltUXXA7N+03NE4Zr5A4zpozr682NbT5SLeNKRoIL/U7v1u5IBxA9jV5OwY95MgXj
# 7kx4Jy5xqPPaoPpffC8nwUw7iHWh7DkZokl4cyKhBxZovvZ31YyQP07qZRknqQ/a
# 3+XXD41MGIDuNnilhFbXc+KqK6IqwJNUHlGeQeo6lAlFmR+VYOkg4QS4M7tjnAEU
# oLQjoiF/LCEIlBuNyjDNop7N8Zc8bBgnEQqL1Fcr9FmTkEYtnd/EJJf+7hUDH3Bn
# cjCCB50wggWFoAMCAQICExwAAAATBX9UckDn3/cAAAAAABMwDQYJKoZIhvcNAQEL
# BQAwVTETMBEGCgmSJomT8ixkARkWA2VkdTEYMBYGCgmSJomT8ixkARkWCG1vbm1v
# dXRoMSQwIgYDVQQDExtNb25tb3V0aCBVbml2ZXJzaXR5IFJvb3QgQ0EwHhcNMTkw
# OTAzMTQ0MDE1WhcNMjQwOTAzMTQ1MDE1WjBdMRMwEQYKCZImiZPyLGQBGRYDZWR1
# MRgwFgYKCZImiZPyLGQBGRYIbW9ubW91dGgxLDAqBgNVBAMTI01vbm1vdXRoIFVu
# aXZlcnNpdHkgSW50ZXJtZWRpYXRlIElJMIICIjANBgkqhkiG9w0BAQEFAAOCAg8A
# MIICCgKCAgEAoJCEcAVs+0A9yxx1eH4CRcHbe6Suq44YmugIQyQ1TOITd26pbfI4
# KjuIhfe13CRuIGPgZi0dpZZvfoIa3MHGI7uFISzreJS2UP9Zylcy5v2QogaZf1A9
# Nwe3jptbIMHkhdE7XyVOjRFWk80vhgYdSDS8vsxOsgrvOIYUAYZHYTkhObrGsWxj
# iT2nQxw82+5snF5e74YO+E8arNEecwy6AiYXk0SGRe4OuLx9X790w/Ll7wFQNUx4
# jjmWyitstYogFsKdqZQRZNPE+JHwSnkJv8zCtFBC31pFzuoSjabJmRsyPfhk2wQb
# S7dMSHxbecEYA/ju5S15mGGYcqMgy+gJrdJTHG+PGzbBmV3S2B7p4rVPDYLb7Vck
# +c7DUNzAXJbMaC3Q2Z6YGV6PoAgHYkNyVkN7OyztDs1/Pvbaq5ngj+bAwHI6PkoA
# Ghun9U00EvJGJSjNtkX9GYJngp5BQrX24+u7jlIKw0O3OFXOhSb7A/1xgC3+iPN0
# o/3OPTnK6Uxi798Q1DR5Ia9mnvT5kR6/WjnwtfVu70FKg9L9M8Nbw9Qjee54BXWE
# uibneU0tCeLACmNYDqGnuuhMR66L3GbdsEhWbRlIAmkC4ccIc7il+c+yjPzUJynH
# PwoDK6GIlG8mSuqxxHaHu+YL6hQpS5mLyl9MMZ0l3Za3fAirsv250UcCAwEAAaOC
# AlwwggJYMBAGCSsGAQQBgjcVAQQDAgEDMCMGCSsGAQQBgjcVAgQWBBRAWCR3eTHi
# KU5I/8or3yFgfpqrFTAdBgNVHQ4EFgQUDp4JuLErNYbWr3zWPysgksrFSrYwGQYJ
# KwYBBAGCNxQCBAweCgBTAHUAYgBDAEEwCwYDVR0PBAQDAgGGMA8GA1UdEwEB/wQF
# MAMBAf8wHwYDVR0jBBgwFoAUfSZeFm7na5Zer/v1G6gnOTj+HcQwggEeBgNVHR8E
# ggEVMIIBETCCAQ2gggEJoIIBBYaBvmxkYXA6Ly8vQ049TW9ubW91dGglMjBVbml2
# ZXJzaXR5JTIwUm9vdCUyMENBLENOPXdsYi1jYS0wMCxDTj1DRFAsQ049UHVibGlj
# JTIwS2V5JTIwU2VydmljZXMsQ049U2VydmljZXMsREM9VW5hdmFpbGFibGVDb25m
# aWdETj9jZXJ0aWZpY2F0ZVJldm9jYXRpb25MaXN0P2Jhc2U/b2JqZWN0Q2xhc3M9
# Y1JMRGlzdHJpYnV0aW9uUG9pbnSGQmh0dHA6Ly9ibHVlaGF3ay5tb25tb3V0aC5l
# ZHUvTW9ubW91dGglMjBVbml2ZXJzaXR5JTIwUm9vdCUyMENBLmNybDCBgwYIKwYB
# BQUHAQEEdzB1MHMGCCsGAQUFBzAChmdmaWxlOi8vLy93bGItY2EtMDAubW9ubW91
# dGguZWR1L0NlcnRFbnJvbGwvd2xiLWNhLTAwLm1vbm1vdXRoLmVkdV9Nb25tb3V0
# aCUyMFVuaXZlcnNpdHklMjBSb290JTIwQ0EuY3J0MA0GCSqGSIb3DQEBCwUAA4IC
# AQA/jDG2oEpLUNySt7OOn+Z9Jq7mJtcFiml3nsvWg9GjGB/V5XJfjDyhlcDfGOlB
# KKAPZMUtYYKJK1kD/YINInwgbSVq9rwty0F6lOaDpHv6JT1WVdKktWGq99QPhYkK
# doMGWgIg6YFt+4+EBl/fJ0mPb7HUKMWWHpNLDxT5nekS5WQNseh6GlxqoKNDnpu3
# edgqU8ApKuPF//4FASe7cIUu8+hfS73Grw/34i+WtnOcgWKAd14+Cn6H+7yeI3ie
# 6aQW2F1IucD2OHELGty6yvIKxRJBe5EovdOg2kbVLSsTzrpHQguFDSsqm0bEqPJd
# UTOHl0u1nZV7uORpTMnjCtA2CyS/NXlml7C3Z3uLEekj2GHHFDoRGZhsAun3nUMS
# yaePT8hq6L25WXHiupxOI25nvGzvYMQPxnTuoN4JlR6YWdxfO6Mh/CvVl+FaD6/N
# g24PKBoTmaPBP5aQpRU0d5oLeJJveLhAafXdYyNjqHhxu28GTdiS7A++3iz+3FUA
# 0mIMKUfp+X6t+U0juqkGDA0GIAz2At6NZiVJhiRAp7DWSyhd87K/AZ/8q/iKYkfM
# A95v0QySNcFws1B2HkXqf8HmAFWUdr36nZuy880rrMUzk2WevFyaMv64lahhRJyi
# RSzI2eZ1hxnapyWmGNtWwWoZ8ieUroahMStlQZ0uIFMt7zGCAZQwggGQAgEBMHQw
# XTETMBEGCgmSJomT8ixkARkWA2VkdTEYMBYGCgmSJomT8ixkARkWCG1vbm1vdXRo
# MSwwKgYDVQQDEyNNb25tb3V0aCBVbml2ZXJzaXR5IEludGVybWVkaWF0ZSBJSQIT
# OwAEGocY570pFDMA/wADAAQahzAJBgUrDgMCGgUAoHgwGAYKKwYBBAGCNwIBDDEK
# MAigAoAAoQKAADAZBgkqhkiG9w0BCQMxDAYKKwYBBAGCNwIBBDAcBgorBgEEAYI3
# AgELMQ4wDAYKKwYBBAGCNwIBFTAjBgkqhkiG9w0BCQQxFgQUvIlG0EWtqnFUpYqc
# KUI87zKUq5UwDQYJKoZIhvcNAQEBBQAEgYBUAw7E7WRd0urZmK93KDOkszeZPoKU
# 4GgOcRRFyriLpEBW8iRh/5Z6hkf/6Q8QYa8D13tj3/CdRa55W2mqVMooWOjfJvpy
# +ac6eAaPWuycwECffy0LglQRrg4OsQ/+BtXOhRlpJjUHc/0Z4Xu6NcwX0FQoLk9s
# PUR/8Q7pyk1w4w==
# SIG # End signature block
